package silastang.camera_flash;


import android.app.Activity;
import android.hardware.camera2.CameraAccessException;
import android.hardware.camera2.CaptureRequest;

import io.flutter.plugins.camera.Camera;
import io.flutter.plugins.camera.DartMessenger;
import io.flutter.view.TextureRegistry;

public class CameraFlash extends Camera {

    public CameraFlash(Activity activity, TextureRegistry.SurfaceTextureEntry flutterTexture, DartMessenger dartMessenger, String cameraName, String resolutionPreset, boolean enableAudio) throws CameraAccessException {
        super(activity, flutterTexture, dartMessenger, cameraName, resolutionPreset, enableAudio);
    }

    public void toggleFlashMode(boolean enable){
        try {
            if (enable) {
                captureRequestBuilder.set(CaptureRequest.FLASH_MODE, CaptureRequest.FLASH_MODE_TORCH);
                captureRequestBuilder.set(CaptureRequest.CONTROL_AE_MODE, CaptureRequest.CONTROL_AE_MODE_ON);
            } else {
                captureRequestBuilder.set(CaptureRequest.FLASH_MODE, CaptureRequest.FLASH_MODE_OFF);
                captureRequestBuilder.set(CaptureRequest.CONTROL_AE_MODE, CaptureRequest.CONTROL_AE_MODE_OFF);
            }
            cameraCaptureSession.setRepeatingRequest(captureRequestBuilder.build(), null, null);
        } catch (CameraAccessException e) {
            e.printStackTrace();
        }
    }
}
