#import "CameraFlashPlugin.h"
#import <AVFoundation/AVFoundation.h>

@implementation CameraFlashPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"plugins.flutter.io/camera_flash"
            binaryMessenger:[registrar messenger]];
  CameraFlashPlugin* instance = [[CameraFlashPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"turnOnFlash" isEqualToString:call.method]) {
     [self turnOnWithIntensity];
     
     result(nil);
  }
   else if ([@"turnOffFlash" isEqualToString:call.method]) {
       [self turnOff];
       result(nil);
   }
  else {
    result(FlutterMethodNotImplemented);
  }
}

- (void) turnOff
{
    AVCaptureDevice *device = [AVCaptureDevice defaultDeviceWithMediaType:AVMediaTypeVideo];
    if ([device hasTorch] && [device hasFlash]){
        [device lockForConfiguration:nil];
        [device setTorchMode:AVCaptureTorchModeOff];
        [device unlockForConfiguration];
    }
}

- (void)turnOnWithIntensity
{
    AVCaptureDevice *device = [AVCaptureDevice defaultDeviceWithMediaType:AVMediaTypeVideo];
       if ([device hasTorch] && [device hasFlash]){
           [device lockForConfiguration:nil];
           NSError *error = nil;
           [device setTorchModeOnWithLevel:1.0 error:&error];
           [device unlockForConfiguration];
       }
}


@end
