import Flutter
import UIKit
import AVKit

public class SwiftCameraFlashPlugin: NSObject, FlutterPlugin {
  var isFlashOn: Bool = false
    
    
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "camera_flash", binaryMessenger: registrar.messenger())
    let instance = SwiftCameraFlashPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    toggleTorch(on: !isFlashOn)
    isFlashOn = !isFlashOn
    result(nil)
  }
    
    func toggleTorch(on: Bool) {
        guard let device = AVCaptureDevice.default(for: .video) else { return }

        if device.hasTorch {
            do {
                try device.lockForConfiguration()

                if on == true {
                    device.torchMode = .on
                } else {
                    device.torchMode = .off
                }

                device.unlockForConfiguration()
            } catch {
                print("Torch could not be used")
            }
        } else {
            print("Torch is not available")
        }
    }
}
