import 'dart:io';

import 'package:flutter/services.dart';
import 'camera-0.5.7+2/lib/camera.dart';

final MethodChannel _channel = const MethodChannel('plugins.flutter.io/camera');
final MethodChannel _iOSChannel = const MethodChannel('plugins.flutter.io/camera_flash');

class FlashCameraController extends CameraController {
  
  FlashCameraController(
      CameraDescription description, 
      ResolutionPreset resolutionPreset) : super(description, resolutionPreset);

  /// Turn on flash
  Future<void> turnOnFlash() async {
    try {
      if (Platform.isAndroid) {
        await _channel.invokeMethod<void>(
            'turnOnFlash'
        );
      } else if (Platform.isIOS) {
        await _iOSChannel.invokeMethod<void>(
            'turnOnFlash'
        );
      }
      return null;
    } on PlatformException catch (e) {
      throw CameraException(e.code, e.message);
    }
  }

  /// Turn off flash
  Future<void> turnOffFlash() async {
    try {
      if (Platform.isAndroid) {
        await _channel.invokeMethod<void>(
            'turnOffFlash'
        );
      } else if (Platform.isIOS) {
        await _iOSChannel.invokeMethod<void>(
            'turnOffFlash'
        );
      }

      return null;
    } on PlatformException catch (e) {
      throw CameraException(e.code, e.message);
    }

  }
}